#include <windows.h>                      
#include <windowsx.h>	//for globalallocptr
#include <vbapi.h>
#include <winsock.h>

#ifndef _DATAGRAM_H_
#define _DATAGRAM_H_	

#ifndef WINAPI  
	#define WINAPI	__far __pascal
#endif                
#ifdef __cplusplus
   extern "C" {
#endif

//Bitmaps to be used as toolbox icon
#define IDBMP_DATAGRAMU                     8000	//VGA up bitmap
#define IDBMP_DATAGRAMDN                    8001	//VGA down bitmap
#define IDBMP_DATAGRAMMONO                  8003	//monochrome bitmap
#define IDBMP_DATAGRAMEGA                   8006	//EGA bitmap

typedef struct vbx_datagram_node
{
	HSZ			mToAddress;
	int			mToPort;
	HSZ			mToData;
	HSZ			mMyAddress;		//read-only
	int			mMyPort;
	long int	mMaxBufferSize;	//read-only
	int			mErrorCode;
	BOOL		mSend;
	BOOL		mConnected;		//read-only @ Design-Time
	BOOL 		mDisconnected;	//read-only @ Design-Time
	SOCKET 		mappsocket;
}VBX_DATAGRAM_NODE;       

typedef VBX_DATAGRAM_NODE __far*	LPVBX_DATAGRAM_NODE;

#define OFFSETIN(struc,field)	  ((USHORT)&(((struc *)0)->field))
#define DATAGRAMDEREF(hctl) ((LPVBX_DATAGRAM_NODE)VBDerefControl(hctl))

LONG FAR PASCAL _export DataGramCtlProc(HCTL, HWND, USHORT, 
	USHORT, LONG);

//add properties
PROPINFO DATAGRAM_ToAddress =
    {
    "ToAddress",	//property name
    DT_HSZ | PF_fGetData | PF_fSetData |PF_fSetMsg| PF_fSaveData,	//property characteristics
    OFFSETIN(VBX_DATAGRAM_NODE, mToAddress)
    };
PROPINFO DATAGRAM_ToPort =
    {
    "ToPort",		//property name
    DT_SHORT | PF_fGetData | PF_fSetData |PF_fSetMsg| PF_fSaveData,	//property characteristics
    OFFSETIN(VBX_DATAGRAM_NODE, mToPort)
    };
PROPINFO DATAGRAM_ToData =
    {
    "ToData",		//property name
    DT_HSZ | PF_fGetData | PF_fSetData |PF_fSetMsg| PF_fSaveData,	//property characteristics
    OFFSETIN(VBX_DATAGRAM_NODE, mToData)
    };
//read-only
PROPINFO DATAGRAM_MyAddress =
    {
    "MyAddress",	//property name
    DT_HSZ | PF_fGetData | PF_fSetData |PF_fSetMsg| PF_fNoRuntimeW,	//property characteristics
    OFFSETIN(VBX_DATAGRAM_NODE, mMyAddress)
    };
PROPINFO DATAGRAM_MyPort =
    {
    "MyPort",		//property name
    DT_SHORT | PF_fGetData | PF_fSetData |PF_fSetMsg| PF_fSaveData,	//property characteristics
    OFFSETIN(VBX_DATAGRAM_NODE, mMyPort)
    };
//read-only
PROPINFO DATAGRAM_MaxBufferSize =
    {
    "MaxBufferSize",//property name
    DT_LONG | PF_fGetData | PF_fSetData |PF_fSetMsg| PF_fNoRuntimeW,//property characteristics
    OFFSETIN(VBX_DATAGRAM_NODE, mMaxBufferSize)
    };
PROPINFO DATAGRAM_ErrorCode =
    {
    "ErrorCode",	//property name
    DT_SHORT | PF_fGetData | PF_fSetData |PF_fSetMsg| PF_fSaveData,	//property characteristics
    OFFSETIN(VBX_DATAGRAM_NODE, mErrorCode)
    };
PROPINFO DATAGRAM_Send =
    {
    "Send",			//property name
    DT_BOOL | PF_fGetData | PF_fSetData |PF_fSetMsg| PF_fSaveData,	//property characteristics
    OFFSETIN(VBX_DATAGRAM_NODE, mSend)
    };
PROPINFO DATAGRAM_Connected =
    {
    "Connected",	//property name
    DT_BOOL | PF_fGetData | PF_fSetData |PF_fSetMsg| PF_fSaveData,	//property characteristics
    OFFSETIN(VBX_DATAGRAM_NODE, mConnected)
    };
PROPINFO DATAGRAM_Disconnected =
    {
    "Disconnected",	//property name
    DT_BOOL | PF_fGetData | PF_fSetData |PF_fSetMsg| PF_fSaveData,	//property characteristics
    OFFSETIN(VBX_DATAGRAM_NODE, mDisconnected)
    };


#define IPROP_DATAGRAM_CTLNAME			0
#define IPROP_DATAGRAM_INDEX			1
#define IPROP_DATAGRAM_PARENT			2
#define IPROP_DATAGRAM_ENABLED			3
#define IPROP_DATAGRAM_LEFT				4
#define IPROP_DATAGRAM_TOP				5
#define IPROP_DATAGRAM_TOADDRESS		6
#define IPROP_DATAGRAM_TOPORT			7
#define IPROP_DATAGRAM_TODATA			8
#define IPROP_DATAGRAM_MYADDRESS		9
#define IPROP_DATAGRAM_MYPORT			10
#define IPROP_DATAGRAM_MAXBUFFERSIZE	11
#define IPROP_DATAGRAM_ERRORCODE		12
#define IPROP_DATAGRAM_SEND				13
#define IPROP_DATAGRAM_CONNECTED		14
#define IPROP_DATAGRAM_DISCONNECTED		15


//supported properties
PPROPINFO DATAGRAM_Properties[] =
    {
    PPROPINFO_STD_CTLNAME,	//standard property
    PPROPINFO_STD_INDEX,   	//standard property
    PPROPINFO_STD_PARENT,	//standard property
    PPROPINFO_STD_ENABLED, 	//standard property
    PPROPINFO_STD_LEFTNORUN,//standard property
    PPROPINFO_STD_TOPNORUN,	//standard property
    &DATAGRAM_ToAddress,	//user-defined property
    &DATAGRAM_ToPort,		//user-defined property
    &DATAGRAM_ToData,		//user-defined property
    &DATAGRAM_MyAddress,	//user-defined property
    &DATAGRAM_MyPort,		//user-defined property
    &DATAGRAM_MaxBufferSize,//user-defined property
    &DATAGRAM_ErrorCode,	//user-defined property
    &DATAGRAM_Send,			//user-defined property
    &DATAGRAM_Connected,	//user-defined property
    &DATAGRAM_Disconnected,	//user-defined property
    NULL
    };

//add events
#define IEVENT_DATAGRAM_DATAIN			0

WORD Params_DataIn[] =
	{
	ET_SD,
	ET_I2,
	ET_SD
	};

typedef struct tagEVENT
{                     
	//reverse order of Event parameters
	HLSTR		FromData;
	int far		*FromPort;
	HLSTR		FromAddr;
	LPVOID		Index;		//always the last parameter in this list
}EVENT_PARAMS;

//the DataIn event
EVENTINFO DATAGRAM_DataIn =
	{                    
		"DataIn",		//Event Name
		3,				//Number of Parameters
		6,				//2X Number of Parameters
		Params_DataIn,
		//VB Event parameter list
		"FromAddress As String, FromPort As Integer, FromData As String"
	};

//supported events
PEVENTINFO DATAGRAM_Events[] =
    {
    &DATAGRAM_DataIn,
    NULL
    };
//the control model
MODEL modelDATAGRAM =
    {
    VB_VERSION, 				// VB version being used
    MODEL_fInvisAtRun,			// MODEL flags
    (PCTLPROC)DataGramCtlProc,	// Control procedure
    CS_VREDRAW|CS_HREDRAW,		// Class style
    WS_BORDER, 					// Default Windows style
    sizeof(VBX_DATAGRAM_NODE),	// Size of CIRC structure
    IDBMP_DATAGRAMU,			// Palette bitmap ID
    "UDP",						// Default control name
    "UDPControl",				// Visual Basic class name
    NULL,						// Parent class name
    DATAGRAM_Properties,		// Property information table
    DATAGRAM_Events,			// Event information table
    IPROP_DATAGRAM_CTLNAME, 	// Default property
    IEVENT_DATAGRAM_DATAIN,		// Default event
    -1							// Property representing value of ctl
    };
#ifdef __cplusplus
   }
#endif
#endif

